#include "em_device.h"

void EMU_setup(void)
{
	EMU->PWRCFG = EMU_PWRCFG_PWRCFG_DCDCTODVDD;		// unlock DCDC registers
	EMU->DCDCMISCCTRL = 15<<16;						// set 320mA current limit
	EMU->DCDCCLIMCTRL = 1<<13;						// enable current limiter
	EMU->DCDCCTRL = 0;								// bypass DCDC
	EMU->PWRCTRL = EMU_PWRCTRL_REGPWRSEL;			// power analog blocks from DVDD
}

void CMU_setup(void)
{
	CMU->OSCENCMD = CMU_OSCENCMD_LFXOEN+CMU_OSCENCMD_LFRCODIS+CMU_OSCENCMD_AUXHFRCOEN;
	while (!(CMU->STATUS & CMU_STATUS_LFXORDY)){}	// wait for LFXO stabilize
	CMU->HFCLKSEL = CMU_HFCLKSEL_HF_HFRCO;			// select 19 MHz HFRCO as clock source
	CMU->HFBUSCLKEN0 = CMU_HFBUSCLKEN0_LE;			// enable LE clock access
	CMU->LFACLKSEL = CMU_LFACLKSEL_LFA_LFXO;		// set LFXO as LFA
	CMU->LFECLKSEL = CMU_LFECLKSEL_LFE_LFXO;
}

void GPIO_setup(void)								// configure GPIO ports
{
	CMU->HFBUSCLKEN0 |= CMU_HFBUSCLKEN0_GPIO;
	(GPIO->P[3]).MODEH |= GPIO_P_MODEH_MODE8_PUSHPULL +
						  GPIO_P_MODEH_MODE9_PUSHPULL;	// red LED control
}

void LETIMER0_setup(void)
{
	CMU->LFACLKEN0 = CMU_LFACLKEN0_LETIMER0;
	LETIMER0->CTRL = LETIMER_CTRL_COMP0TOP +		// set 1 sec period
			LETIMER_CTRL_UFOA0_TOGGLE;				// toggle output pin
	LETIMER0->COMP0 = 32767;
	LETIMER0->ROUTELOC0 = LETIMER_ROUTELOC0_OUT0LOC_LOC17;
	LETIMER0->ROUTEPEN = LETIMER_ROUTEPEN_OUT0PEN;
	LETIMER0->REP0 = 1;
//	LETIMER0->IEN = LETIMER_IEN_UF;					// enable LETIMER interrupt
	LETIMER0->CMD = LETIMER_CMD_START + LETIMER_CMD_CLEAR;
//	NVIC_EnableIRQ(LETIMER0_IRQn);
}
